- Qt 6.8
- Qt GUI
- C++ Classes
- QTextObject
- Qt 6.8.3 Reference Documentation

# QTextObject Class

The QTextObject class is a base class for different kinds of objects that can group parts of a QTextDocument together. More...

Header: | `#include <QTextObject>`
CMake: | `find_package(Qt6 REQUIRED COMPONENTS Gui)` `target_link_libraries(mytarget PRIVATE Qt6::Gui)`
qmake: | `QT += gui`
Inherits: | QObject
Inherited By: | QTextBlockGroup and QTextFrame

- List of all members, including inherited members
- QTextObject is part of Rich Text Processing APIs.

Note: All functions in this class are reentrant.

## Public Functions

QTextDocument * | document() const
QTextFormat | format() const
int | formatIndex() const
int | objectIndex() const

## Protected Functions

| QTextObject(QTextDocument *document)
virtual | ~QTextObject()
void | setFormat(const QTextFormat &format)

## Detailed Description

The common grouping text objects are lists (QTextList), frames (QTextFrame), and tables (QTextTable). A text object has an associated format() and document().

There are essentially two kinds of text objects: those that are used with blocks (block formats), and those that are used with characters (character formats). The first kind are derived from QTextBlockGroup, and the second kind from QTextFrame.

You rarely need to use this class directly. When creating custom text objects, you will also need to reimplement QTextDocument::createObject() which acts as a factory method for creating text objects.

See also QTextDocument.

## Member Function Documentation

### `[explicit protected]` QTextObject::QTextObject(QTextDocument *document)

Creates a new QTextObject for the given document.

Warning: This function should never be called directly, but only from QTextDocument::createObject().

### `[virtual noexcept protected]` QTextObject::~QTextObject()

Destroys the text object.

Warning: Text objects are owned by the document, so you should never destroy them yourself.

### QTextDocument *QTextObject::document() const

Returns the document this object belongs to.

See also format().

### QTextFormat QTextObject::format() const

Returns the text object's format.

See also setFormat() and document().

### int QTextObject::formatIndex() const

Returns the index of the object's format in the document's internal list of formats.

See also QTextDocument::allFormats().

### int QTextObject::objectIndex() const

Returns the object index of this object. This can be used together with QTextFormat::setObjectIndex().

### `[protected]` void QTextObject::setFormat(const QTextFormat &format)

Sets the text object's format.

See also format().